'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var Link = (function () {
  function Link(link, parent) {
    _classCallCheck(this, Link);

    this._rawLink = link;
    this._parent = parent;
  }

  _createClass(Link, [{
    key: 'getHref',
    value: function getHref() {
      return this._rawLink.href.replace(/{(.+?)}/, function (_, m) {
        return ':' + decodeURIComponent(m).replace(/[()\s]/g, '').split('/').pop();
      });
    }
  }, {
    key: 'getMethod',
    value: function getMethod() {
      return this._rawLink.method;
    }
  }, {
    key: 'getContentType',
    value: function getContentType() {
      return this._rawLink.encType || 'application/json';
    }
  }, {
    key: 'getTargetSchema',
    value: function getTargetSchema() {
      return this._rawLink.targetSchema;
    }
  }, {
    key: 'hasResponseBody',
    value: function hasResponseBody() {
      return this._rawLink.mediaType !== 'null';
    }
  }, {
    key: 'getResponseStatus',
    value: function getResponseStatus() {
      if (this.getMethod() === 'POST') {
        return 201;
      } else if (this.hasResponseBody()) {
        return 200;
      } else {
        return 204;
      }
    }
  }, {
    key: 'getResponseSchema',
    value: function getResponseSchema() {
      return this.getTargetSchema() || this._parent;
    }
  }, {
    key: 'hasListData',
    value: function hasListData() {
      return this._rawLink.rel === 'instances';
    }
  }, {
    key: 'getResponseHash',
    value: function getResponseHash() {
      return Link.generateResponse(this.getResponseSchema().properties);
    }
  }, {
    key: 'getResponseBody',
    value: function getResponseBody() {
      var result = this.hasListData() ? [this.getResponseHash()] : this.getResponseHash();
      return JSON.stringify(result);
    }
  }], [{
    key: 'generateResponse',
    value: function generateResponse(properties) {
      var _this = this;

      return _Object$keys(properties).reduce(function (result, key) {
        var value = properties[key];
        var example = value.example;
        var items = value.items;
        var type = value.type;

        var types = Array.isArray(type) ? type : [type];

        if (value.properties) {
          result[key] = _this.generateResponse(value.properties);
        } else if (example !== undefined) {
          result[key] = example;
        } else if (types.some(function (v) {
          return v === 'null';
        })) {
          result[key] = null;
        } else if (types.some(function (v) {
          return v === 'array';
        })) {
          if (items.example !== undefined) {
            result[key] = [items.example];
          } else {
            result[key] = [_this.generateResponse(items.properties)];
          }
        } else {
          throw new Error('No example found for "' + key + '"');
        }
        return result;
      }, {});
    }
  }]);

  return Link;
})();

exports['default'] = Link;
module.exports = exports['default'];