'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _morgan = require('morgan');

var _morgan2 = _interopRequireDefault(_morgan);

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _Schema = require('./Schema');

var _Schema2 = _interopRequireDefault(_Schema);

var MockServe = (function () {
  function MockServe(options) {
    _classCallCheck(this, MockServe);

    var port = options.port;
    var path = options.path;

    this._path = path;
    this._port = port;
    this._app = (0, _express2['default'])();
    this._app.use(_bodyParser2['default'].json());
    this._app.use(_bodyParser2['default'].urlencoded({ extended: true }));
    this._app.use((0, _morgan2['default'])('[:date[clf]] ":method :url HTTP/:http-version" :status :res[content-length]'));
  }

  _createClass(MockServe, [{
    key: 'start',
    value: function start() {
      var _this = this;

      var schema = _Schema2['default'].load(require(this._path));
      var resources = schema.resources;

      _Object$keys(resources).forEach(function (name) {
        var resource = resources[name];
        resource.links.forEach(function (link, index) {
          var method = link.getMethod().toLowerCase();
          try {
            link.getResponseBody();
          } catch (e) {
            throw new Error(e.message + ' at definitions.' + name + '.links[' + index + ']');
          }
          if (_this._app[method]) {
            _this._app[method](link.getHref(), function (req, res) {
              res.set('Content-Type', link.getContentType());
              res.status(link.getResponseStatus()).send(link.getResponseBody());
            });
          } else {
            throw new Error('Not Support.');
          }
        });
      });
      this._app.listen(this._port);
      console.log('Mock server started http://localhost:' + this._port);
    }
  }]);

  return MockServe;
})();

exports['default'] = MockServe;
module.exports = exports['default'];