'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var Visitor = (function () {
  function Visitor(rootSchema) {
    _classCallCheck(this, Visitor);

    this._rootSchema = rootSchema;
  }

  _createClass(Visitor, [{
    key: 'run',
    value: function run() {
      var _this = this;

      var resources = this._rootSchema.properties;

      var path = '#/properties';
      return _Object$keys(resources).reduce(function (result, resourceName) {
        var resourcePath = path + '/' + resourceName;
        var resource = resources[resourceName];
        if (_this.shouldResolveReference(resource)) {
          resource = resources[resourceName] = _this.resolveReference(resource.$ref);
        }
        resource.properties = _this.visitProperties(resource.properties || {});
        resource.links = _this.visitLinks(resource.links || [], resource, resourcePath + '/links');
        result[resourceName] = resource;
        return result;
      }, {});
    }
  }, {
    key: 'resolveReference',
    value: function resolveReference(path) {
      return path.slice(2).split('/').reduce(function (current, node) {
        return current[node];
      }, this._rootSchema);
    }
  }, {
    key: 'shouldResolveReference',
    value: function shouldResolveReference(schema) {
      return schema.$ref !== undefined;
    }
  }, {
    key: 'visitProperties',
    value: function visitProperties(properties) {
      var _this2 = this;

      return _Object$keys(properties).reduce(function (result, propertyName) {
        var property = properties[propertyName];
        if (_this2.shouldResolveReference(property)) {
          property = properties[propertyName] = _this2.resolveReference(property.$ref);
        }
        result[propertyName] = property;
        return result;
      }, {});
    }
  }, {
    key: 'visitLinks',
    value: function visitLinks(links, resource, path) {
      var _this3 = this;

      return links.map(function (link, index) {
        if (_this3.hasTargetSchema(link)) {
          link.targetSchema = _this3.visitTargetSchema(link.targetSchema, path + '[' + index + ']/targetSchema');
        }
        return new _Link2['default'](link, resource);
      });
    }
  }, {
    key: 'visitTargetSchema',
    value: function visitTargetSchema(schema, path) {
      var _this4 = this;

      var properties = schema.properties;
      var items = schema.items;

      if (properties) {
        schema.properties = _Object$keys(properties).reduce(function (result, key) {
          result[key] = _this4.visitTargetSchema(properties[key], path + '/properties/' + key);
          return result;
        }, {});
      } else if (items) {
        schema.items = this.visitTargetSchema(schema.items, path + '/items');
      } else if (this.shouldResolveReference(schema)) {
        return this.resolveReference(schema.$ref);
      } else {
        console.log('[WARNING] Invalid TargetSchema has been detected. at ' + path);
        console.log(schema);
      }
      return schema;
    }
  }, {
    key: 'hasTargetSchema',
    value: function hasTargetSchema(link) {
      return link.targetSchema !== undefined;
    }
  }]);

  return Visitor;
})();

exports['default'] = Visitor;
module.exports = exports['default'];